=== modified file 'client/drizzledump.cc'
--- client/drizzledump.cc	2010-04-02 07:45:12 +0000
+++ client/drizzledump.cc	2010-04-01 17:45:30 +0000
@@ -35,8 +35,8 @@
 #include "drizzled/internal/my_sys.h"
 #include "drizzled/internal/m_string.h"
 #include "drizzled/charset_info.h"
-#include "drizzled/hash.h"
 #include <stdarg.h>
+#include <drizzled/unordered_set.h>
 #include <algorithm>
 
 #include <drizzled/gettext.h>
@@ -153,7 +153,7 @@
 static TYPELIB compatible_mode_typelib= {array_elements(compatible_mode_names) - 1,
   "", compatible_mode_names, NULL};
 
-drizzled::hash_set<string> ignore_table;
+unordered_set<string> ignore_table;
 
 static struct option my_long_options[] =
 {
@@ -2341,7 +2341,7 @@
 static bool include_table(const char *hash_key, size_t key_size)
 {
   string match(hash_key, key_size);
-  drizzled::hash_set<string>::iterator iter= ignore_table.find(match);
+  unordered_set<string>::iterator iter= ignore_table.find(match);
   return (iter == ignore_table.end());
 }
 

=== modified file 'client/drizzletest.cc'
--- client/drizzletest.cc	2010-04-02 07:45:12 +0000
+++ client/drizzletest.cc	2010-04-01 17:45:30 +0000
@@ -58,12 +58,12 @@
 #include PCRE_HEADER
 
 #include <stdarg.h>
+#include <drizzled/unordered_map.h>
 
 #include "errname.h"
 
 /* Added this for string translation. */
 #include "drizzled/gettext.h"
-#include "drizzled/hash.h"
 #include "drizzled/drizzle_time.h"
 #include "drizzled/charset.h"
 
@@ -208,7 +208,7 @@
 VAR var_reg[10];
 
 
-drizzled::hash_map<string, VAR *> var_hash;
+unordered_map<string, VAR *> var_hash;
 
 struct st_connection
 {
@@ -1703,7 +1703,7 @@
       die("Too long variable name: %s", save_var_name);
 
     string save_var_name_str(save_var_name, length);
-    drizzled::hash_map<string, VAR*>::iterator iter=
+    unordered_map<string, VAR*>::iterator iter=
       var_hash.find(save_var_name_str);
     if (iter == var_hash.end())
     {
@@ -1741,7 +1741,7 @@
 static VAR *var_obtain(const char *name, int len)
 {
   string var_name(name, len);
-  drizzled::hash_map<string, VAR*>::iterator iter=
+  unordered_map<string, VAR*>::iterator iter=
     var_hash.find(var_name);
   if (iter != var_hash.end())
     return (*iter).second;

=== modified file 'config/pandora-plugin'
--- config/pandora-plugin	2010-03-23 08:39:53 +0000
+++ config/pandora-plugin	2010-04-01 17:45:30 +0000
@@ -125,8 +125,6 @@
 echo "   * Debug enabled:             $with_debug"
 echo "   * Warnings as failure:       $ac_cv_warnings_as_errors"
 echo "   * C++ cstdint location:      $ac_cv_cxx_cstdint"
-echo "   * C++ hash_map location:     $ac_cv_cxx_hash_map"
-echo "   * C++ hash namespace:        $ac_cv_cxx_hash_namespace"
 echo "   * C++ shared_ptr namespace:  $ac_cv_shared_ptr_namespace"
 echo ""
 echo "---"

=== modified file 'configure.ac'
--- configure.ac	2010-03-22 21:30:21 +0000
+++ configure.ac	2010-04-01 17:45:30 +0000
@@ -153,8 +153,6 @@
 echo "   * Coverage enabled:          $ac_coverage"
 echo "   * Warnings as failure:       $ac_cv_warnings_as_errors"
 echo "   * C++ cstdint location:      $ac_cv_cxx_cstdint"
-echo "   * C++ hash_map location:     $ac_cv_cxx_hash_map"
-echo "   * C++ hash namespace:        $ac_cv_cxx_hash_namespace"
 echo "   * C++ shared_ptr namespace:  $ac_cv_shared_ptr_namespace"
 echo ""
 echo "---"

=== modified file 'drizzled/error.cc'
--- drizzled/error.cc	2010-03-11 18:27:20 +0000
+++ drizzled/error.cc	2010-04-01 17:45:30 +0000
@@ -27,8 +27,8 @@
 #include "drizzled/definitions.h"
 #include "drizzled/error.h"
 #include "drizzled/gettext.h"
-#include "drizzled/hash.h"
 
+#include <drizzled/unordered_map.h>
 #include <exception>
 
 namespace drizzled
@@ -70,7 +70,7 @@
   ErrorMap(const ErrorMap &e);
   ErrorMap& operator=(const ErrorMap &e);
 
-  typedef drizzled::hash_map<uint32_t, std::string> ErrorMessageMap;
+  typedef unordered_map<uint32_t, std::string> ErrorMessageMap;
   ErrorMessageMap mapping_;
 };
 

=== removed file 'drizzled/hash.h'
--- drizzled/hash.h	2009-11-25 21:17:01 +0000
+++ drizzled/hash.h	1970-01-01 00:00:00 +0000
@@ -1,274 +0,0 @@
-/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
- *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
- *
- *  Copyright (C) 2009 Sun Microsystems
- *
- *  This program is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License as published by
- *  the Free Software Foundation; version 2 of the License.
- *
- *  This program is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this program; if not, write to the Free Software
- *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
- */
-
-// Protocol Buffers - Google's data interchange format
-// Copyright 2008 Google Inc.  All rights reserved.
-// http://code.google.com/p/protobuf/
-//
-// Redistribution and use in source and binary forms, with or without
-// modification, are permitted provided that the following conditions are
-// met:
-//
-//     * Redistributions of source code must retain the above copyright
-// notice, this list of conditions and the following disclaimer.
-//     * Redistributions in binary form must reproduce the above
-// copyright notice, this list of conditions and the following disclaimer
-// in the documentation and/or other materials provided with the
-// distribution.
-//     * Neither the name of Google Inc. nor the names of its
-// contributors may be used to endorse or promote products derived from
-// this software without specific prior written permission.
-//
-// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
-// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
-// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
-// A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
-// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
-// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
-// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
-// DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
-// THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
-// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
-// OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
-
-// Author: kenton@google.com (Kenton Varda)
-//
-// Deals with the fact that hash_map is not defined everywhere.
-
-#ifndef DRIZZLED_HASH_H
-#define DRIZZLED_HASH_H
-
-#include <cstring>
-#include <string>
-
-#if defined(HAVE_HASH_MAP) && defined(HAVE_HASH_SET)
-#include HASH_MAP_H
-#include HASH_SET_H
-#else
-#define MISSING_HASH
-#include <map>
-#include <set>
-#endif
-
-namespace drizzled {
-
-#ifdef MISSING_HASH
-
-// This system doesn't have hash_map or hash_set.  Emulate them using map and
-// set.
-
-// Make hash<T> be the same as less<T>.  Note that everywhere where custom
-// hash functions are defined in the protobuf code, they are also defined such
-// that they can be used as "less" functions, which is required by MSVC anyway.
-template <typename Key>
-struct hash {
-  // Dummy, just to make derivative hash functions compile.
-  int operator()(const Key& key) {
-    assert(0);
-    return 0;
-  }
-
-  inline bool operator()(const Key& a, const Key& b) const {
-    return a < b;
-  }
-};
-
-// Make sure char* is compared by value.
-template <>
-struct hash<const char*> {
-  // Dummy, just to make derivative hash functions compile.
-  int operator()(const char*) {
-    assert(0);
-    return 0;
-  }
-
-  inline bool operator()(const char* a, const char* b) const {
-    return strcmp(a, b) < 0;
-  }
-};
-
-template <typename Key, typename Data,
-          typename HashFcn = hash<Key>,
-          typename EqualKey = int >
-class hash_map : public std::map<Key, Data, HashFcn> {
-
-  void rehash(size_t buckets_in)
-  {
-    resize(buckets_in);
-  }
-};
-
-template <typename Key,
-          typename HashFcn = hash<Key>,
-          typename EqualKey = int >
-class hash_set : public std::set<Key, HashFcn> {
-  void rehash(size_t buckets_in)
-  {
-    resize(buckets_in);
-  }
-};
-
-#elif defined(_MSC_VER) && !defined(_STLPORT_VERSION)
-
-template <typename Key>
-struct hash : public HASH_NAMESPACE::hash_compare<Key> {
-};
-
-// MSVC's hash_compare<const char*> hashes based on the string contents but
-// compares based on the string pointer.  WTF?
-class CstringLess {
- public:
-  inline bool operator()(const char* a, const char* b) const {
-    return strcmp(a, b) < 0;
-  }
-};
-
-template <>
-struct hash<const char*>
-  : public HASH_NAMESPACE::hash_compare<const char*, CstringLess> {
-};
-
-template <typename Key, typename Data,
-          typename HashFcn = hash<Key>,
-          typename EqualKey = int >
-class hash_map : public HASH_NAMESPACE::HASH_MAP_CLASS<
-    Key, Data, HashFcn> {
-#if !defined(HASH_MAP_HAS_REHASH)
-public:
-  void rehash(size_t buckets_in)
-  {
-# if defined(HASH_MAP_HAS_RESIZE)
-    resize(buckets_in);
-# endif /* HASH_MAP_HAS_RESIZE */
-  }
-#endif /* HASH_MAP_HAS_REHASH */
-};
-
-template <typename Key,
-          typename HashFcn = hash<Key>,
-          typename EqualKey = int >
-class hash_set : public HASH_NAMESPACE::HASH_SET_CLASS<
-    Key, HashFcn> {
-#if !defined(HASH_MAP_HAS_REHASH)
-public:
-  void rehash(size_t buckets_in)
-  {
-# if defined(HASH_MAP_HAS_RESIZE)
-    resize(buckets_in);
-# endif /* HASH_MAP_HAS_RESIZE */
-  }
-#endif /* HASH_MAP_HAS_REHASH */
-};
-
-#else
-
-template <typename Key>
-struct hash : public HASH_NAMESPACE::hash<Key> {
-};
-
-template <typename Key>
-struct hash<const Key*> {
-  inline size_t operator()(const Key* key) const {
-    return reinterpret_cast<size_t>(key);
-  }
-};
-
-template <>
-struct hash<const char*> : public HASH_NAMESPACE::hash<const char*> {
-};
-
-template <typename Key, typename Data,
-          typename HashFcn = hash<Key>,
-          typename EqualKey = std::equal_to<Key> >
-class hash_map : public HASH_NAMESPACE::HASH_MAP_CLASS<
-    Key, Data, HashFcn, EqualKey> {
-#if !defined(HASH_MAP_HAS_REHASH)
-public:
-  void rehash(size_t buckets_in)
-  {
-# if defined(HASH_MAP_HAS_RESIZE)
-    HASH_NAMESPACE::HASH_MAP_CLASS<Key, Data, HashFcn, EqualKey>::resize(buckets_in);
-# endif /* HASH_MAP_HAS_RESIZE */
-  }
-#endif /* HASH_MAP_HAS_REHASH */
-};
-
-template <typename Key,
-          typename HashFcn = hash<Key>,
-          typename EqualKey = std::equal_to<Key> >
-class hash_set : public HASH_NAMESPACE::HASH_SET_CLASS<
-    Key, HashFcn, EqualKey> {
-#if !defined(HASH_MAP_HAS_REHASH)
-public:
-  void rehash(size_t buckets_in)
-  {
-# if defined(HASH_MAP_HAS_RESIZE)
-    HASH_NAMESPACE::HASH_SET_CLASS<Key, HashFcn, EqualKey>::resize(buckets_in);
-# endif /* HASH_MAP_HAS_RESIZE */
-  }
-#endif /* HASH_MAP_HAS_REHASH */
-};
-
-#endif
-
-#if defined(REDEFINE_HASH_STRING)
-template <>
-struct hash<std::string> {
-  inline size_t operator()(const std::string& key) const {
-    return hash<const char*>()(key.c_str());
-  }
-
-  static const size_t bucket_size = 4;
-  static const size_t min_buckets = 8;
-  inline size_t operator()(const std::string& a, const std::string& b) const {
-    return a < b;
-  }
-};
-#endif
-
-template <typename First, typename Second>
-struct hash<std::pair<First, Second> > {
-  inline size_t operator()(const std::pair<First, Second>& key) const {
-    size_t first_hash = hash<First>()(key.first);
-    size_t second_hash = hash<Second>()(key.second);
-
-    // FIXME(kenton):  What is the best way to compute this hash?  I have
-    // no idea!  This seems a bit better than an XOR.
-    return first_hash * ((1 << 16) - 1) + second_hash;
-  }
-
-  static const size_t bucket_size = 4;
-  static const size_t min_buckets = 8;
-  inline size_t operator()(const std::pair<First, Second>& a,
-                           const std::pair<First, Second>& b) const {
-    return a < b;
-  }
-};
-
-// Used by GCC/SGI STL only.  (Why isn't this provided by the standard
-// library?  :( )
-struct streq {
-  inline bool operator()(const char* a, const char* b) const {
-    return strcmp(a, b) == 0;
-  }
-};
-
-}  /* namespace drizzled */
-
-#endif /* DRIZZLED_HASH_H */

=== modified file 'drizzled/include.am'
--- drizzled/include.am	2010-04-08 07:20:26 +0000
+++ drizzled/include.am	2010-04-14 21:40:03 +0000
@@ -193,7 +193,6 @@
 			      drizzled/ha_statistics.h \
 			      drizzled/cursor.h \
 			      drizzled/handler_structs.h \
-			      drizzled/hash.h \
 			      drizzled/hybrid_type.h \
 			      drizzled/hybrid_type_traits.h \
 			      drizzled/hybrid_type_traits_decimal.h \
@@ -421,6 +420,8 @@
 			      drizzled/tztime.h \
 			      drizzled/unique.h \
 			      drizzled/unireg.h \
+			      drizzled/unordered_map.h \
+			      drizzled/unordered_set.h \
 			      drizzled/user_var_entry.h \
 			      drizzled/utf8.h \
 			      drizzled/utf8/checked.h \

=== modified file 'drizzled/plugin/function.cc'
--- drizzled/plugin/function.cc	2009-12-21 09:40:31 +0000
+++ drizzled/plugin/function.cc	2010-04-01 17:45:30 +0000
@@ -20,8 +20,10 @@
 
 /* This implements 'user defined functions' */
 #include "config.h"
+
+#include <drizzled/unordered_map.h>
+
 #include <drizzled/gettext.h>
-#include "drizzled/hash.h"
 #include "drizzled/plugin/function.h"
 
 using namespace std;
@@ -29,7 +31,7 @@
 namespace drizzled
 {
 
-typedef hash_map<string, const plugin::Function *> UdfMap;
+typedef unordered_map<string, const plugin::Function *> UdfMap;
 static UdfMap udf_registry;
 
 bool plugin::Function::addPlugin(const plugin::Function *udf)

=== modified file 'drizzled/plugin/storage_engine.h'
--- drizzled/plugin/storage_engine.h	2010-04-13 07:19:47 +0000
+++ drizzled/plugin/storage_engine.h	2010-04-14 21:40:03 +0000
@@ -33,7 +33,7 @@
 #include "drizzled/cached_directory.h"
 #include "drizzled/plugin/monitored_in_transaction.h"
 
-#include "drizzled/hash.h"
+#include <drizzled/unordered_map.h>
 
 #include <bitset>
 #include <string>
@@ -120,7 +120,7 @@
 namespace plugin
 {
 
-typedef hash_map<std::string, StorageEngine *> EngineMap;
+typedef unordered_map<std::string, StorageEngine *> EngineMap;
 typedef std::vector<StorageEngine *> EngineVector;
 
 typedef std::set<std::string> TableNameList;

=== modified file 'drizzled/plugin/xa_resource_manager.cc'
--- drizzled/plugin/xa_resource_manager.cc	2010-03-03 20:21:57 +0000
+++ drizzled/plugin/xa_resource_manager.cc	2010-04-01 17:45:30 +0000
@@ -30,7 +30,6 @@
 #include <drizzled/plugin/xa_resource_manager.h>
 #include "drizzled/xid.h"
 
-#include "drizzled/hash.h"
 
 #include <string>
 #include <vector>

=== modified file 'drizzled/plugin/xa_storage_engine.cc'
--- drizzled/plugin/xa_storage_engine.cc	2010-03-03 20:21:57 +0000
+++ drizzled/plugin/xa_storage_engine.cc	2010-04-01 17:45:30 +0000
@@ -30,8 +30,6 @@
 #include <drizzled/plugin/xa_storage_engine.h>
 #include "drizzled/xid.h"
 
-#include "drizzled/hash.h"
-
 #include <string>
 #include <vector>
 #include <algorithm>

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2010-04-02 07:45:12 +0000
+++ drizzled/session.h	2010-04-01 17:45:30 +0000
@@ -1421,7 +1421,7 @@
   bool lock_table_name_if_not_cached(const char *db,
                                      const char *table_name, Table **table);
 
-  typedef drizzled::hash_map<std::string, message::Table> TableMessageCache;
+  typedef unordered_map<std::string, message::Table> TableMessageCache;
   TableMessageCache table_message_cache;
 
   bool storeTableMessage(TableIdentifier &identifier, message::Table &table_message);

=== modified file 'drizzled/table_function_container.h'
--- drizzled/table_function_container.h	2010-02-05 08:11:15 +0000
+++ drizzled/table_function_container.h	2010-04-01 17:45:30 +0000
@@ -21,13 +21,13 @@
 #ifndef DRIZZLED_TABLE_FUNCTION_CONTAINER_H
 #define DRIZZLED_TABLE_FUNCTION_CONTAINER_H
 
-#include "drizzled/hash.h"
+#include <drizzled/unordered_map.h>
 #include <set>
 
 namespace drizzled {
 
 class TableFunctionContainer {
-  typedef hash_map<std::string, plugin::TableFunction *> ToolMap;
+  typedef unordered_map<std::string, plugin::TableFunction *> ToolMap;
 
   ToolMap table_map;
 

=== modified file 'drizzled/table_share.cc'
--- drizzled/table_share.cc	2010-03-22 15:30:40 +0000
+++ drizzled/table_share.cc	2010-04-01 17:45:30 +0000
@@ -33,7 +33,6 @@
 #include "drizzled/error.h"
 #include "drizzled/gettext.h"
 #include "drizzled/sql_base.h"
-#include "drizzled/hash.h"
 #include "drizzled/pthread_globals.h"
 #include "drizzled/internal/my_pthread.h"
 
@@ -59,7 +58,7 @@
   /* 
    * This is going to overalloc a bit - as rehash sets the number of
    * buckets, not the number of elements. BUT, it'll allow us to not need
-   * to rehash later on as the hash_map grows.
+   * to rehash later on as the unordered_map grows.
    */
   table_def_cache.rehash(table_def_size);
 }

=== modified file 'drizzled/table_share.h'
--- drizzled/table_share.h	2010-03-26 19:56:34 +0000
+++ drizzled/table_share.h	2010-04-01 17:45:30 +0000
@@ -28,6 +28,8 @@
 
 #include <string>
 
+#include <drizzled/unordered_map.h>
+
 #include "drizzled/typelib.h"
 #include "drizzled/my_hash.h"
 #include "drizzled/memory/root.h"
@@ -36,7 +38,7 @@
 namespace drizzled
 {
 
-typedef drizzled::hash_map<std::string, TableShare *> TableDefinitionCache;
+typedef unordered_map<std::string, TableShare *> TableDefinitionCache;
 
 const static std::string STANDARD_STRING("STANDARD");
 const static std::string TEMPORARY_STRING("TEMPORARY");

=== added file 'drizzled/unordered_map.h'
--- drizzled/unordered_map.h	1970-01-01 00:00:00 +0000
+++ drizzled/unordered_map.h	2010-04-01 17:45:30 +0000
@@ -0,0 +1,78 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+/**
+ * @file
+ *
+ * Includes either std::unordered_map if we have it, or boost::unordered_map
+ * if we don't. Puts them into the drizzled namespace
+ */
+
+#ifndef DRIZZLED_UNORDERED_MAP_H
+#define DRIZZLED_UNORDERED_MAP_H
+
+#ifdef HAVE_STD_UNORDERED_MAP
+# include <unordered_map>
+#else
+# ifdef HAVE_TR1_UNORDERED_MAP
+#  include <tr1/unordered_map>
+# else
+#  ifdef HAVE_BOOST_UNORDERED_MAP
+#   include <boost/unordered_map.hpp>
+#  else
+#   include <map>
+#   include <functional>
+#  endif
+# endif
+#endif
+
+namespace drizzled {
+
+#ifdef HAVE_STD_UNORDERED_MAP
+using std::unordered_map;
+using std::hash;
+#else
+# ifdef HAVE_TR1_UNORDERED_MAP
+using std::tr1::unordered_map;
+using std::tr1::hash;
+# else
+#  ifdef HAVE_BOOST_UNORDERED_MAP
+using boost::unordered_map;
+using boost::hash;
+#  else
+
+template <typename Key, typename Data,
+          typename HashFcn = std::less<Key>,
+          typename EqualKey = int >
+class unordered_map :
+  public std::map<Key, Data, HashFcn>
+{ 
+public:
+  void rehash(size_t)
+  { }
+};
+
+#  endif /* HAVE_BOOST_UNORDERED_MAP else */
+# endif /* HAVE_TR1_UNORDERED_MAP else */
+#endif /* HAVE_STD_UNORDERED_MAP else */
+
+
+}  /* namespace drizzled */
+
+#endif /* DRIZZLED_UNORDERED_MAP_H */

=== added file 'drizzled/unordered_set.h'
--- drizzled/unordered_set.h	1970-01-01 00:00:00 +0000
+++ drizzled/unordered_set.h	2010-04-01 17:45:30 +0000
@@ -0,0 +1,78 @@
+/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Monty Taylor
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; version 2 of the License.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+/**
+ * @file
+ *
+ * Includes either std::unordered_set if we have it, or boost::unordered_set
+ * if we don't. Puts them into the drizzled namespace
+ */
+
+#ifndef DRIZZLED_UNORDERED_SET_H
+#define DRIZZLED_UNORDERED_SET_H
+
+#ifdef HAVE_STD_UNORDERED_SET
+# include <unordered_set>
+#else
+# ifdef HAVE_TR1_UNORDERED_SET
+#  include <tr1/unordered_set>
+# else
+#  ifdef HAVE_BOOST_UNORDERED_SET
+#   include <boost/unordered_set.hpp>
+#  else
+#   include <set>
+#   include <functional>
+#  endif
+# endif
+#endif
+
+namespace drizzled {
+
+#ifdef HAVE_STD_UNORDERED_SET
+using std::unordered_set;
+using std::hash;
+#else
+# ifdef HAVE_TR1_UNORDERED_SET
+using std::tr1::unordered_set;
+using std::tr1::hash;
+# else
+#  ifdef HAVE_BOOST_UNORDERED_SET
+using boost::unordered_set;
+using boost::hash;
+#  else
+
+template <typename Key,
+          typename HashFcn = std::less<Key>,
+          typename EqualKey = int >
+class unordered_set :
+  public std::set<Key, HashFcn>
+{ 
+public:
+  void rehash(size_t)
+  { }
+};
+
+#  endif /* HAVE_BOOST_UNORDERED_SET else */
+# endif /* HAVE_TR1_UNORDERED_SET else */
+#endif /* HAVE_STD_UNORDERED_SET else */
+
+
+}  /* namespace drizzled */
+
+#endif /* DRIZZLED_UNORDERED_SET_H */

=== modified file 'm4/pandora_canonical.m4'
--- m4/pandora_canonical.m4	2010-03-25 22:03:21 +0000
+++ m4/pandora_canonical.m4	2010-04-01 17:45:30 +0000
@@ -4,7 +4,7 @@
 dnl with or without modifications, as long as this notice is preserved.
 
 dnl Which version of the canonical setup we're using
-AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.116])
+AC_DEFUN([PANDORA_CANONICAL_VERSION],[0.118])
 
 AC_DEFUN([PANDORA_FORCE_DEPEND_TRACKING],[
   AC_ARG_ENABLE([fat-binaries],

=== modified file 'm4/pandora_drizzle_build.m4'
--- m4/pandora_drizzle_build.m4	2010-03-22 21:30:21 +0000
+++ m4/pandora_drizzle_build.m4	2010-04-01 17:45:30 +0000
@@ -9,8 +9,7 @@
 
 AC_DEFUN([PANDORA_DRIZZLE_BUILD],[
 
-  dnl We need to turn on our CXXFLAGS to make sure it shows up correctly
-  PANDORA_CXX_STL_HASH
+  PANDORA_HAVE_CXX_UNORDERED
 
   PANDORA_CXX_CSTDINT
   PANDORA_CXX_CINTTYPES

=== modified file 'm4/pandora_stl_hash.m4'
--- m4/pandora_stl_hash.m4	2009-12-14 23:47:11 +0000
+++ m4/pandora_stl_hash.m4	2010-04-01 17:45:30 +0000
@@ -1,110 +1,89 @@
-# We check two things: where the include file is for hash_map, and
-# what namespace hash_map lives in within that include file.  We
+# We check two things: where the include file is for unordered_map, and
+# what namespace unordered_map lives in within that include file.  We
 # include AC_COMPILE_IFELSE for all the combinations we've seen in the
-# wild.  We define one of HAVE_HASH_MAP or HAVE_EXT_HASH_MAP depending
-# on location, and HASH_NAMESPACE to be the namespace hash_map is
-# defined in.
-#
-# Ideally we'd use AC_CACHE_CHECK, but that only lets us store one value
-# at a time, and we need to store two (filename and namespace).
-# prints messages itself, so we have to do the message-printing ourselves
-# via AC_MSG_CHECKING + AC_MSG_RESULT.  (TODO(csilvers): can we cache?)
-
-AC_DEFUN([PANDORA_CXX_STL_HASH],
-  [AC_MSG_CHECKING(the location of hash_map)
-   save_CXXFLAGS="${CXXFLAGS}"
-   CXXFLAGS="${AM_CXXFLAGS} ${CXXFLAGS}"
-   AC_LANG_PUSH(C++)
-   ac_cv_cxx_hash_map=""
-   for location in "" "ext/" "tr1/" ; do
-     for namespace in __gnu_cxx "" std stdext; do
-       for classprefix in unordered hash; do
-         if test -z "$ac_cv_cxx_hash_map"; then
-           AC_COMPILE_IFELSE(
-             [AC_LANG_PROGRAM([[#include <${location}${classprefix}_map>]],
-                           [[${namespace}::${classprefix}_map<int, int> t]])],
-             [ac_cv_cxx_hash_map="<${location}${classprefix}_map>";
-              ac_cv_cxx_hash_set="<${location}${classprefix}_set>";
-              ac_cv_cxx_hash_namespace="$namespace";
-              ac_cv_cxx_hash_map_class="${classprefix}_map";
-              ac_cv_cxx_hash_set_class="${classprefix}_set"])
-
-         fi
-       done
-     done
-   done
-
-   if test -n "$ac_cv_cxx_hash_map"; then
-      AC_DEFINE(HAVE_HASH_MAP, 1, [define if the compiler has hash_map])
-      AC_DEFINE(HAVE_HASH_SET, 1, [define if the compiler has hash_set])
-      AC_DEFINE_UNQUOTED(HASH_MAP_H,$ac_cv_cxx_hash_map,
-                         [the location of <hash_map>])
-      AC_DEFINE_UNQUOTED(HASH_SET_H,$ac_cv_cxx_hash_set,
-                         [the location of <hash_set>])
-      AC_DEFINE_UNQUOTED(HASH_NAMESPACE,$ac_cv_cxx_hash_namespace,
-                         [the namespace of hash_map/hash_set])
-      AC_DEFINE_UNQUOTED(HASH_MAP_CLASS,$ac_cv_cxx_hash_map_class,
-                         [the classname of hash_map])
-      AC_DEFINE_UNQUOTED(HASH_SET_CLASS,$ac_cv_cxx_hash_set_class,
-                         [the classname of hash_set])
-      AC_MSG_RESULT([$ac_cv_cxx_hash_map])
-   else
-      AC_MSG_RESULT()
-      AC_MSG_WARN([could not find an STL hash_map])
-   fi
-   AC_CACHE_CHECK(
-     [whether hash_map has rehash method],
-     [ac_cv_hash_map_has_rehash],
-     [AC_COMPILE_IFELSE(
-       [AC_LANG_PROGRAM([[
-#include HASH_MAP_H
-using namespace HASH_NAMESPACE;
-       ]],[[
-HASH_MAP_CLASS<int, int> test_hash;
-test_hash.rehash(100);
-          ]])],
-       [ac_cv_hash_map_has_rehash=yes],
-       [ac_cv_hash_map_has_rehash=no])])
-   AS_IF([test $ac_cv_hash_map_has_rehash = yes],[
-      AC_DEFINE(HASH_MAP_HAS_REHASH, 1, [if hash_map<> hash rehash method])
-   ])
-   AC_CACHE_CHECK(
-     [whether hash_map has resize method],
-     [ac_cv_hash_map_has_resize],
-     [AC_COMPILE_IFELSE(
-       [AC_LANG_PROGRAM([[
-#include HASH_MAP_H
-using namespace HASH_NAMESPACE;
-       ]],[[
-HASH_MAP_CLASS<int, int> test_hash;
-test_hash.resize(100);
-          ]])],
-       [ac_cv_hash_map_has_resize=yes],
-       [ac_cv_hash_map_has_resize=no])])
-   AS_IF([test $ac_cv_hash_map_has_resize = yes],[
-      AC_DEFINE(HASH_MAP_HAS_RESIZE, 1, [if hash_map<> hash resize method])
-   ])
-   AC_CACHE_CHECK(
-     [whether to redefine hash<string>],
-     [ac_cv_redefine_hash_string],
-     [AC_COMPILE_IFELSE(
-       [AC_LANG_PROGRAM([[
-#include HASH_SET_H
-#include <string>
-using namespace HASH_NAMESPACE;
-using namespace std;
-          ]],[[
-string teststr("test");
-HASH_SET_CLASS<string> test_hash;
-HASH_SET_CLASS<string>::iterator iter= test_hash.find(teststr);
-if (iter != test_hash.end())
-  return 1;
-          ]])],
-       [ac_cv_redefine_hash_string=no],
-       [ac_cv_redefine_hash_string=yes])])
-   AS_IF([test $ac_cv_redefine_hash_string = yes],[
-      AC_DEFINE(REDEFINE_HASH_STRING, 1, [if hash<string> needs to be defined])
-   ])
-   CXXFLAGS="${save_CXXFLAGS}"
-   AC_LANG_POP()
+# wild.  We define HAVE_UNORDERED_MAP and HAVE_UNORDERED_SET if we have
+# them, UNORDERED_MAP_H and UNORDERED_SET_H to their location and
+# UNORDERED_NAMESPACE to be the namespace unordered_map is defined in.
+
+AC_DEFUN([PANDORA_CXX_STL_UNORDERED],[
+  save_CXXFLAGS="${CXXFLAGS}"
+  CXXFLAGS="${AM_CXXFLAGS} ${CXXFLAGS}"
+  AC_LANG_PUSH(C++)
+  AC_CACHE_CHECK([for STL unordered_map],
+    [pandora_cv_stl_unordered],[
+      AC_COMPILE_IFELSE(
+        [AC_LANG_PROGRAM([[#include <unordered_map>]],
+                         [[std::unordered_map<int, int> t]])],
+        [pandora_cv_stl_unordered="yes"],
+        [pandora_cv_stl_unordered="no"])])
+
+  AS_IF([test "x${pandora_cv_stl_unordered}" != "xyes"],[
+    AC_CACHE_CHECK([for tr1 unordered_map],
+      [pandora_cv_tr1_unordered],[
+        AC_COMPILE_IFELSE(
+          [AC_LANG_PROGRAM([[
+/* We put in this define because of a YACC symbol clash in Drizzle.
+   Seriously... I cannot believe the GCC guys defined a piece of the internals
+   of this named IF - and I can't believe that YACC generates a token define
+   called IF. Really?
+*/
+#define IF 21;
+#include <tr1/unordered_map>
+            ]],[[
+std::tr1::unordered_map<int, int> t
+          ]])],
+          [pandora_cv_tr1_unordered="yes"],
+          [pandora_cv_tr1_unordered="no"])])
+  ])
+
+  AS_IF([test "x${pandora_cv_stl_unordered}" != "xyes" -a "x${pandora_cv_tr1_unordered}" != "xyes"],[
+    AC_CACHE_CHECK([for boost unordered_map],
+      [pandora_cv_boost_unordered],[
+        AC_COMPILE_IFELSE(
+          [AC_LANG_PROGRAM([[#include <boost/unordered_map.hpp>]],
+                           [[boost::unordered_map<int, int> t]])],
+          [pandora_cv_boost_unordered="yes"],
+          [pandora_cv_boost_unordered="no"])])
+  ])
+
+  CXXFLAGS="${save_CXXFLAGS}"
+  AC_LANG_POP()
+
+  AS_IF([test "x${pandora_cv_stl_unordered}" = "xyes"],[
+    AC_DEFINE(HAVE_STD_UNORDERED_MAP, 1,
+              [if the compiler has std::unordered_map])
+    AC_DEFINE(HAVE_STD_UNORDERED_SET, 1,
+              [if the compiler has std::unordered_set])
+    pandora_has_unordered=yes
+  ])
+  AS_IF([test "x${pandora_cv_tr1_unordered}" = "xyes"],[
+    AC_DEFINE(HAVE_TR1_UNORDERED_MAP, 1,
+              [if the compiler has std::tr1::unordered_map])
+    AC_DEFINE(HAVE_TR1_UNORDERED_SET, 1,
+              [if the compiler has std::tr1::unordered_set])
+    pandora_has_unordered=yes
+  ])
+  AS_IF([test "x${pandora_cv_boost_unordered}" = "xyes"],[
+    AC_DEFINE(HAVE_BOOST_UNORDERED_MAP, 1,
+              [if the compiler has boost::unordered_map])
+    AC_DEFINE(HAVE_BOOST_UNORDERED_SET, 1,
+              [if the compiler has boost::unordered_set])
+    pandora_has_unordered=yes
+  ])
+    
+  AS_IF([test "x${pandora_has_unordered}" != "xyes"],[
+    AC_MSG_WARN([could not find an STL unordered_map])
+  ])
+])
+
+AC_DEFUN([PANDORA_HAVE_CXX_UNORDERED],[
+  AC_REQUIRE([PANDORA_CXX_STL_UNORDERED])
+])
+
+AC_DEFUN([PANDORA_REQUIRE_CXX_UNORDERED],[
+  AC_REQUIRE([PANDORA_HAVE_CXX_UNORDERED])
+  AS_IF([test "x${pandora_has_unordered}" != "xyes"],[
+    AC_MSG_ERROR([An STL compliant unordered_map is required for ${PACKAGE}.
+    Implementations can be found in Recent versions of gcc and in boost])
+  ])
 ])

=== modified file 'plugin/memcached_stats/analysis_table.cc'
--- plugin/memcached_stats/analysis_table.cc	2010-04-06 23:15:47 +0000
+++ plugin/memcached_stats/analysis_table.cc	2010-04-07 20:44:20 +0000
@@ -35,6 +35,7 @@
 #include "drizzled/error.h"
 
 #include <libmemcached/memcached.h>
+#include <libmemcached/server.h>
 
 using namespace std;
 using namespace drizzled;
@@ -93,11 +94,11 @@
 
     push(static_cast<uint64_t>(server_count));
     push(static_cast<uint64_t>(report->average_item_size));
-    push(memcached_server_name(&servers[report->most_consumed_server]));
+    push(memcached_server_name(serv, servers[report->most_consumed_server]));
     push(report->most_used_bytes);
-    push(memcached_server_name(&servers[report->least_free_server]));
+    push(memcached_server_name(serv, servers[report->least_free_server]));
     push(report->least_remaining_bytes);
-    push(memcached_server_name(&servers[report->oldest_server]));
+    push(memcached_server_name(serv, servers[report->oldest_server]));
     push(static_cast<uint64_t>(report->longest_uptime));
     push(static_cast<int64_t>(report->pool_hit_ratio));
     free(report);

=== modified file 'plugin/memcached_stats/stats_table.cc'
--- plugin/memcached_stats/stats_table.cc	2010-04-06 23:15:47 +0000
+++ plugin/memcached_stats/stats_table.cc	2010-04-07 20:44:20 +0000
@@ -33,6 +33,7 @@
 #include "sysvar_holder.h"
 
 #include "drizzled/error.h"
+#include <libmemcached/server.h>
 
 using namespace std;
 using namespace drizzled;
@@ -43,7 +44,7 @@
 
 extern "C"
 memcached_return  server_function(const memcached_st *ptr,
-                                  const memcached_server_st *server,
+                                  memcached_server_st *server,
                                   void *context);
 
 
@@ -58,13 +59,13 @@
 
 extern "C"
 memcached_return  server_function(const memcached_st *memc,
-                                  const memcached_server_st *server,
+                                  memcached_server_st *server,
                                   void *context)
 {
   server_function_context *ctx= static_cast<server_function_context *>(context);
 
-  const char *server_name= memcached_server_name(server);
-  in_port_t server_port= memcached_server_port(server);
+  const char *server_name= memcached_server_name(*memc, *server);
+  in_port_t server_port= memcached_server_port(*memc, *server);
 
   memcached_stat_st stats;
   memcached_return ret= memcached_stat_servername(&stats, NULL,
@@ -184,7 +185,7 @@
 
   server_function_context context(this);
 
-  memcached_server_fn callbacks[1];
+  memcached_server_function callbacks[1];
   callbacks[0]= server_function;
 
   unsigned int iferror; 

=== modified file 'plugin/pool_of_threads/pool_of_threads.cc'
--- plugin/pool_of_threads/pool_of_threads.cc	2010-03-06 02:08:13 +0000
+++ plugin/pool_of_threads/pool_of_threads.cc	2010-04-07 16:51:14 +0000
@@ -56,7 +56,7 @@
   void libevent_kill_session_callback(int Fd, short Operation, void *ctx);
 }
 
-static uint32_t size= 0;
+static uint32_t pool_size= 0;
 
 /**
  * @brief 
@@ -322,7 +322,7 @@
   */
   (void) pthread_mutex_lock(&LOCK_thread_count);
   created_threads++;
-  if (created_threads == size)
+  if (created_threads == pool_size)
     (void) pthread_cond_signal(&COND_thread_count);
   (void) pthread_mutex_unlock(&LOCK_thread_count);
 
@@ -608,7 +608,7 @@
   /* Set up the thread pool */
   pthread_mutex_lock(&LOCK_thread_count);
 
-  for (x= 0; x < size; x++)
+  for (x= 0; x < pool_size; x++)
   {
     pthread_t thread;
     int error;
@@ -622,7 +622,7 @@
   }
 
   /* Wait until all threads are created */
-  while (created_threads != size)
+  while (created_threads != pool_size)
     pthread_cond_wait(&COND_thread_count,&LOCK_thread_count);
   pthread_mutex_unlock(&LOCK_thread_count);
 
@@ -638,7 +638,7 @@
  */
 static int init(drizzled::plugin::Context &context)
 {
-  assert(size != 0);
+  assert(pool_size != 0);
 
   scheduler= new PoolOfThreadsScheduler("pool_of_threads");
   context.add(scheduler);
@@ -650,7 +650,7 @@
  The defaults here were picked based on what I see (aka Brian). They should
  be vetted across a larger audience.
 */
-static DRIZZLE_SYSVAR_UINT(size, size,
+static DRIZZLE_SYSVAR_UINT(size, pool_size,
                            PLUGIN_VAR_RQCMDARG,
                            N_("Size of Pool."),
                            NULL, NULL, 8, 1, 1024, 0);

=== modified file 'plugin/pool_of_threads/pool_of_threads.h'
--- plugin/pool_of_threads/pool_of_threads.h	2010-02-04 08:14:46 +0000
+++ plugin/pool_of_threads/pool_of_threads.h	2010-04-01 17:45:30 +0000
@@ -29,7 +29,7 @@
 #include "session_scheduler.h"
 #include <string>
 #include <queue>
-#include <set>
+#include <drizzled/unordered_set.h>
 #include <event.h>
 
 
@@ -58,9 +58,9 @@
    *
    * This should really be a collection of unordered Sessions. No one is more
    * promising to encounter an io event earlier than another; so no order
-   * indeed! We will change this to unordered_set/hash_set when c++0x comes.
+   * indeed!
    */
-  std::set<drizzled::Session *> sessions_waiting_for_io;
+  drizzled::unordered_set<drizzled::Session *> sessions_waiting_for_io;
 
 public:
   PoolOfThreadsScheduler(const char *name_arg);

=== modified file 'plugin/schema_engine/schema.h'
--- plugin/schema_engine/schema.h	2010-04-01 16:08:35 +0000
+++ plugin/schema_engine/schema.h	2010-04-01 17:45:30 +0000
@@ -24,7 +24,7 @@
 #include <assert.h>
 #include <drizzled/plugin/storage_engine.h>
 #include <drizzled/data_home.h>
-#include <drizzled/hash.h>
+#include <drizzled/unordered_map.h>
 
 #include <pthread.h>
 
@@ -41,7 +41,7 @@
 
   void prime();
 
-  typedef drizzled::hash_map<std::string, drizzled::message::Schema> SchemaCache;
+  typedef drizzled::unordered_map<std::string, drizzled::message::Schema> SchemaCache;
   SchemaCache schema_cache;
   bool schema_cache_filled;
 

=== modified file 'plugin/version/versionudf.cc'
--- plugin/version/versionudf.cc	2010-03-06 02:08:13 +0000
+++ plugin/version/versionudf.cc	2010-04-07 16:51:05 +0000
@@ -46,7 +46,7 @@
 
 String *VersionFunction::val_str(String *str)
 {
-  str->set(version().c_str(), version().size(),
+  str->set(::drizzled::version().c_str(), ::drizzled::version().size(),
            system_charset_info);
   return str;
 }

